/*
 * ir.c
 *
 *  Created on: 2014-5-2
 *      Author: twd2
 */

#include "ir.h"

void ir_init() {
	IR_IN;
}

unsigned char ir_readhead() {
	while(IR_DATA);
	unsigned int l=0,h=0;
	while(!IR_DATA && l<100) {
		++l;
		utils_delay_us(100);
	}
	while(IR_DATA && h<100) {
		++h;
		utils_delay_us(100);
	}
	return ((l>50) && (h>30)) || ((l>20 && l<50) && (h>15));
}

int ir_read(unsigned char *buff, unsigned int maxn) {
	ir_init();

	if (!ir_readhead())
		return -1; //head error

	unsigned int i, j;
	for(i=maxn;i!=0;--i) {
		*buff=0;
		for(j=8;j!=0;--j) {

			unsigned long l=0,h=0;
			while(!IR_DATA && l<100) {
				++l;
				utils_delay_us(100);
			}
			while(IR_DATA && h<25) {
				++h;
				utils_delay_us(100);
			}

			if(h>=25)
				return maxn-i; //read error

			//*buff>>=1;
			*buff |= (h>9)<<(8-j); //LSBǰ
		}
		++buff;
	}
	return maxn;
}

short ir_readbyte() {
	unsigned char buff[1];
	int count;
	count=ir_read(buff,1);
	if (count>0) {
		return buff[0];
	} else {
		return -1;
	}
}

void ir_nec_send(unsigned char *buff, unsigned int count) {
	ir_init();
	unsigned int i, j;
	ir_nec_head();
	for(i=0;i!=count;++i) {
		for(j=0;j!=8;++j) {
			if ( (buff[i]>>j) & 1 ) {
				ir_nec_1();
			} else {
				ir_nec_0();
			}
		}
	}
	ir_nec_pulse();
}
void ir_nec_sendbyte(unsigned char ch) {
	unsigned char buff[1];
	buff[0]=ch;
	ir_nec_send(buff, 1);
}
