/*
 * ir.h
 *
 *  Created on: 2014-5-2
 *      Author: twd2
 */



#ifndef IR_H_
#define IR_H_

#include <msp430.h>
#include "utils.h"

#define IR_PORT_DIR P1DIR
#define IR_IN_BIT BIT5
#define IR_IN (IR_PORT_DIR &= ~IR_IN_BIT)
#define IR_DATA ((P1IN & IR_IN_BIT) == IR_IN_BIT)
#define IR_OUT_BIT BIT7
#define IR_OUT (IR_PORT_DIR |= IR_OUT_BIT)
#define IR_1 (P1OUT |= IR_OUT_BIT)
#define IR_0 (P1OUT &= ~IR_OUT_BIT)

void ir_init();
unsigned char ir_readhead();
int ir_read(unsigned char *, unsigned int);
short ir_readbyte();
void ir_nec_send(unsigned char *, unsigned int);
void ir_nec_sendbyte(unsigned char);
#define ir_tick() \
{ \
	IR_1; \
	utils_delay_us(12.5); \
	IR_0; \
	utils_delay_us(12.5); \
}
#define ir_nec_head() \
{ \
	unsigned int i=360+1; \
	while(--i) { \
		ir_tick(); \
	} \
	utils_delay_us(4500); \
}
#define ir_nec_pulse() \
{ \
	unsigned int i=23+1; \
	while(--i) { \
		ir_tick(); \
	} \
}
#define ir_nec_0() \
{ \
	ir_nec_pulse(); \
	utils_delay_us(1125-560); \
}
#define ir_nec_1() \
{ \
	ir_nec_pulse(); \
	utils_delay_us(2250-560); \
}

#endif /* IR_H_ */
